<?php

/*!! Structure.Actions.AdminEditTable:
  .      .

  FIELDS: ##:::: ...##
## :-  :  : :  ##

:

  * tname - table name
  * key - key in the table (one field only!)
  * fields - show fields

@link Examples.DB:
 1:    ,   :
%%(code)
{{adminviewtable tname="zayavki" header=":::::" fields="family:name:otchestvo:klass:pansion:adddata" key="id"}}

{{adminedittable tname="zayavki" fields=":family:text: :::name:text: :::otchestvo:text: :: :klass:text: ::  ( '+',  ,       ):pansion:text: :: ,      :adddata:textarea: " key="id" btnadd=" "}}
%%

 2:   **adminbasicontology**:

%%(phpplus)
if($this->IsAdmin()) {
   // security init
   $this->secAdminedittable = true;
   $this->secAdminviewtable = true;
   // init adminviewtable
   $tname='basicontology';
   $header='ID:::';
   $fields='id:owner:name:title';
   $maxsymbols = 120;
   $atype = "compact";
   include('actions/adminviewtable.php');

   echo "<br />";
   // init adminedittable
   $fields=':owner:text:SiteAdmin:::name:text: :::title:text: ';
   include('actions/adminedittable.php');
   //security finalization
   $this->secAdminedittable = false;
   $this->secAdminviewtable = false;
}
%%

 3 -     (    notparse):
%%(phpplus)
if($this->IsAdmin()) {
   // security init
   $this->secAdminedittable = true;
   $this->secAdminviewtable = true;
   // init adminviewtable
   $tname='wiki_proverb_model';
   $header='id:ID ::: ';
   $fields='id:modelId:username:writetime:latest';
   $maxsymbols = 120;
   $atype = "compact";
   include('actions/adminviewtable.php');

   echo "<br />";
   // init adminedittable
   $notparse = '1';
   $fieldar = array ( array ('ID ','modelId','int', ''),
                      array ('','username','tselect table="users" field="name" key="name"', ''),
                      array ('','writetime','datetime', ''),
                      array (' ','latest','checkbox', '0'),
              );

   include('actions/adminedittable.php');
   //security finalization
   $this->secAdminedittable = false;
   $this->secAdminviewtable = false;
}
%%
@link Structure.Actions, Function.DB, User.Developer:
!!  .!!
*/

if($this->secAdminedittable) {
// case complex JS
$_GET["editid"] = $this->tryUtfDecode($_GET["editid"]);

if($key=="") $key="id";
if($max==0) $max=10;

if(isset($firstcolwidth)) $firstcolwidth = (int)$firstcolwidth; else $firstcolwidth = 12;

//if($onlyadd=="1") $onlyadd=true; else $onlyadd=false;


if ($_POST["preview"]) {
   echo "<i>Unitable     </i><br />";
} else {

  //    -  
  if($notparse!='1') {
     $fieldar1 = explode("::",$fields);
     $fieldar = array();
     foreach($fieldar1 as $field) {
       $fieldar[] = explode(":",$field);
     }
  }

  if($_POST["abstract_add"]=='1') {
     // antispam feature
     $accept = $this->GetUser();
     if(!$accept) {
         $accept = (int)$_REQUEST["aspam"] + 5 == (int)$_REQUEST["aspammsg"];
     }
     if($accept) {
                $sqlst = "";
                foreach($fieldar as $fldinfo) {
                   $curvar = "";
                   $curvar = $this->vfrmProcess($fldinfo[2],$fldinfo[1]);
                   $sqlst .= ", ".$fldinfo[1]."='".quote($curvar)."'";
               }
               $sqlst = substr($sqlst,1);

               if($_POST[$key.'nafig']=="") {
                    $this->Query('INSERT INTO '.$this->config["table_prefix"].$tname." SET ".$sqlst);
                    $this->SetMessage($msgadd?$msgadd:"    $tname");
               } else {
                  if(!$onlyadd) {
                    $this->Query('UPDATE '.$this->config["table_prefix"].$tname." SET ".$sqlst." WHERE $key='".quote($_POST[$key.'nafig'])."'");
                    $this->SetMessage($msgedit?$msgedit:"    $tname");
                  }
               }
               $this->redirect($this->href());
     } else {
           $this->SetMessage('   .   .');
           $this->Arefresh();
     }
  } else {
  if (($_GET["deleteid"]!='') && !$onlyadd) {
      $this->Query('DELETE FROM '.$this->config["table_prefix"].$tname." WHERE $key='".quote($_GET["deleteid"])."'");
      $this->SetMessage("    $tname");
      $this->redirect($this->href());
  } else {
      if(!$onlyadd && !$hideheader) echo "<div align=center><i>  $tname</i></div><br>\n";
      echo "<table width=100% border=0>";

      $isedit = false;
      if (($_GET["editid"]!='') && !$onlyadd) {
           $isedit=true;
           $curab = $this->LoadSingle('SELECT * FROM `'.$this->config["table_prefix"].$tname."` WHERE $key='".quote($_GET["editid"])."'");
      }
      ?>
      <form name="editform" method="POST">
      <input type="hidden" name="abstract_add" value="1">
      <?php
        // antispam feature
              if(!$this->GetUser()) {
                  $antiSpamId = rand(1,100);
              } else {
                  $antiSpamId = 0;
              }


        foreach($fieldar as $fldinfo) {
            echo "<tr><td align=right>".$fldinfo[0]."</td><td></td><td>";
            echo $this->vfrmField($fldinfo[1],$fldinfo[2],$isedit?$curab[$fldinfo[1]]:trim($fldinfo[3]));
            echo "</td></tr>\n";
        }
        if($isedit) echo '<input type="hidden" name="'.$key.'nafig" value='.$_GET["editid"].'>';
      ?>
      <tr><td width=<?php echo $firstcolwidth; ?>%></td><td width=1%></td><td>
      <?php
         if($antiSpamId!=0) {
            echo '<input type="hidden" name="aspam" value="'.$antiSpamId.'" />';
            echo ',   '.$antiSpamId.'+5: <input type="text" name="aspammsg" />        .<br />';
         }
      ?>


      <input type="submit" value="<?php if($isedit) echo ($btnedit?$btnedit:""); else echo ($btnadd?$btnadd:""); ?>" /></td></tr>
      <?
      echo $this->FormClose();
      echo "</table>";
  }
  }

}
}
?>
