<?php
class xmini10
{
        function xmini10()
        {
                $this->description = "Xmini 1.0";
                $this->author = "Janvarev Vladislav";
                $this->priority = 200;
        }

        function format($info)
        {
                $classname = 'XmRemote'.ucfirst(str_replace('.','_',$info['package'].$info['class']));
                ob_start();
                include(dirname(__FILE__)."/xmini10.tpl");
                return ob_get_clean();
        }

        function save($info, $where, $overwrite)
        {
                $classname = 'XmRemote'.ucfirst(str_replace('.','_',$info['package'].$info['class']));

                 //First create package hierarchy
                $package = '';

                if(!is_dir($where . '/' . $package))
                {
                        //Create the directory
                        $attempt = makeDirs($where . '/' . $package);

                        if($attempt === FALSE)
                        {
                                return "could not create directory $where/$package";
                        }
                }

                chdir($where . '/' . $package);

                //Put content
                $template = $this->format($info);

                if($overwrite || !file_exists($classname . '.as'))
                {
                        $r = file_put_contents($classname . '.as', $template);
                        if($r === FALSE)
                        {
                                return "Could not create file " . $classname;
                        }
                }
                return TRUE;
        }
}
